10 Rem SUPER STARTREK - MAY 16, 1978 - REQUIRES 64K MEMORY
20 Rem REWRITTEN EXCLUSIVELY FOR QB64PE ON 09/01/2024
30 Rem  New version v1.0a
40 Rem    Includes Romulans and a Vulcan starbase.
50 Rem  New version v2.0a
60 Rem    And function softkeys and row 24 statusline.
70 Rem    Now prompts for Captains name.
80 Rem  New version v3.0a
90 Rem    Adds several new commands.
92 Rem      Including BUY/PUR/RND/TOP.
93 Rem  New version v4.0a includes
94 Rem    All text prints lowercased.
95 Rem    Adds color statements to all prints.
97 Rem    Adds Executive command.
98 Rem    Adds Top Ten Captain datafile.
99 Rem    Adds Save/Load current game.
100 Rem   Moves instructions to textfile.
110 Rem   Adds Ferengi starbase.
111 Rem   Adds debris around destroyed ship.
112 Rem   Deletes debris during phasers.
113 Rem  New version v5.0a includes
114 Rem   Adds Save/Load games number parameter.
115 Rem   Adds Quit command.
116 Rem   Adds Init command.
117 Rem   Adds date/time to Top 10.
118 Rem   Also allows debris around deleted star.
119 Rem   Ferengis give things away for free.
120 Rem   Moves some filenames to constants.

128 Rem color constants
129 ' high intensity foreground
130 Const Black = 0
131 Const Plain = 7
132 Const Gray = 8
133 Const Blue = 9
134 Const Green = 10
135 Const Cyan = 11
136 Const Red = 12
137 Const Magenta = 13
138 Const Yellow = 14
139 Const White = 15

140 Rem filename constants.
141 Const FL = "STREKTOP.DAT"
142 Const FL1 = "STREKDOC.TXT"
143 Const FL2 = "STREKTOP.TXT"
144 Const FL3 = "STREKTOP.ANS"

150 Rem setup main startup.
Rem $Checking:Off
212 Rem $Dynamic
213 DefSng A-Z
214 Width 80, 25: View Print 1 To 23
215 _ScreenMove _Middle
Rem ' for qb45 because of unsupported underscore.
235 Dim Quote As String * 1: Quote = Chr$(34)
236 ReDim Names(10) As String

240 Rem begin program here:
247 On Error GoTo 10001216
248 Locate 23, 1, 1: GoSub 9580: GoSub 9645: GoSub 100020
249 Color White: Print "Press enter to start game";: Input X$
250 For I = 1 To 10: Print: Next I: Color Yellow
251 Print "                                    ,------*------,"
252 Print "                    ,-------------   '---  ------'"
253 Print "                     '-------- --'      / /"
254 Print "                         ,---' '-------/ /--,"
255 Print "                          '----------------'": Print
256 Color White: Print "                    The USS Enterprise --- NCC-1701"
257 For I = 1 To 5: Print: Next I
259 Color White: Print "Enter Captains name";: Input CP$: CP$ = UCase$(CP$)

260 Rem adjust captains name.
261 If CP$ = "" Then CP$ = Names$(1): GoTo 265
262 Rem If CP$ = "???" Then CP$ = Names$(1): GoTo 265
263 If CP$ = Names$(2) Or CP$ = Names$(3) Or CP$ = Names$(4) Or CP$ = Names$(5) Then Color Red: Print "Staff name already in use.": GoTo 259

264 Rem adjust lieutenant names.
265 C1$ = Names$(6): If CP$ = Names$(6) Then CX$ = C1$: CX2$ = C1$: GoSub 9592: C1$ = R1$
266 C2$ = Names$(7): If C2$ = C1$ Or C2$ = CP$ Then 268
267 GoTo 300
268 C2$ = Names$(9): If C2$ = C1$ Or C2$ = CP$ Then CX$ = C1$: CX2$ = CP$: GoSub 9592: C2$ = R1$

269 Rem lowercase and captalize ship officer names.
300 CP$ = LCase$(CP$): Mid$(CP$, 1, 1) = UCase$(Mid$(CP$, 1, 1)) ' captain
301 C1$ = LCase$(C1$): Mid$(C1$, 1, 1) = UCase$(Mid$(C1$, 1, 1)) ' lieutenant
302 C2$ = LCase$(C2$): Mid$(C2$, 1, 1) = UCase$(Mid$(C2$, 1, 1)) ' lieutenant
303 C3$ = LCase$(Names$(3)): Mid$(C3$, 1, 1) = UCase$(Mid$(C3$, 1, 1)) ' chief engineer
304 C4$ = LCase$(Names$(2)): Mid$(C4$, 1, 1) = UCase$(Mid$(C4$, 1, 1)) ' commander
305 C5$ = LCase$(Names$(4)): Mid$(C5$, 1, 1) = UCase$(Mid$(C5$, 1, 1)) ' doctor

309 Rem setup arrays and values.
310 Randomize Timer
320 Z$ = Space$(25)
330 ReDim G(8, 8), C(9, 2), K(4, 3), N(3), Z(8, 8), D(9), R(4, 3)
331 For I = 1 To 8: For J = 1 To 8: G(I, J) = 0: Z(I, J) = 0: Next J: Next I
332 For I = 1 To 9: For J = 1 To 2: C(I, J) = 0: Next J: Next I
333 For I = 1 To 4: For J = 1 To 3: K(I, J) = 0: R(I, J) = 0: Next J: Next I
334 For I = 1 To 3: N(I) = 0: Next I: For I = 1 To 9: D(I) = 0: Next I
370 T = Int(Rnd(1) * 20 + 20) * 100: T0 = T: T9 = 25 + Int(Rnd(1) * 10): D0 = 0: E = 10000: E0 = E: Q9 = 0: G1 = 1
440 P1 = 10: P = 30: P0 = P: S9 = 200: S = 250: B9 = 0: K9 = 0: R9 = 0: X$ = "": X0$ = " IS "

441 Rem setup starbase coordinates.
445 VX = Int(Rnd * 8 + 1): VY = Int(Rnd * 8 + 1)
446 QX = Int(Rnd * 8 + 1): QY = Int(Rnd * 8 + 1): If VX = QX And VY = QY Then 446

480 Rem Initialize Enterprise position.
490 Q1 = Int(Rnd * 8 + 1): Q2 = Int(Rnd * 8 + 1): S1 = Int(Rnd * 8 + 1): S2 = Int(Rnd * 8 + 1)
530 For I = 1 To 9: C(I, 1) = 0: C(I, 2) = 0: Next I
540 C(3, 1) = -1: C(2, 1) = -1: C(4, 1) = -1: C(4, 2) = -1: C(5, 2) = -1: C(6, 2) = -1
600 C(1, 2) = 1: C(2, 2) = 1: C(6, 1) = 1: C(7, 1) = 1: C(8, 1) = 1: C(8, 2) = 1: C(9, 2) = 1
670 For I = 1 To 9: D(I) = 0: Next I
690 XX = 0: Cash = 10000 ' amount of credits

700 Rem setup commands.
710 A1$ = "NAVSRSLRSPHATORSHEDAMCOMXXXFIXINC???PHOGENLOCDISSEAHLPINSRATRNDBUYPURLSTEXETOPSAVLOA"
711 KEY 1, "NAV" + Chr$(13): KEY 2, "SRS" + Chr$(13): KEY 3, "LRS" + Chr$(13): KEY 4, "PHA" + Chr$(13)
712 KEY 5, "TOR" + Chr$(13): KEY 6, "SHE" + Chr$(13): KEY 7, "DAM" + Chr$(13): KEY 8, "COM" + Chr$(13)
713 KEY 9, "FIX" + Chr$(13): KEY 10, "INC" + Chr$(13): KEY 30, "PHO" + Chr$(13): KEY 31, "GEN" + Chr$(13)
714 Color White: KEY On: Color Plain

810 Rem Setup what exists in Galaxy.
815 Rem K3 = # Klingons  B3 = # Starbases  S3 = # Stars  R3 = # Romulans.
820 For I = 1 To 8: For J = 1 To 8: K3 = 0: R3 = 0: Z(I, J) = 0: R1 = Rnd(1)
      830 If R1 > .99 Then K3 = 4: K9 = K9 + 4: GoTo 880
      850 If R1 > .98 Then K3 = 3: K9 = K9 + 3: GoTo 880
      860 If R1 > .95 Then K3 = 2: K9 = K9 + 2: GoTo 880
      870 If R1 > .8 Then K3 = 1: K9 = K9 + 1
      880 R1 = Rnd(1)
      910 If R1 > .95 Then R3 = 2: R9 = R9 + 2: GoTo 980
      920 If R1 > .85 Then R3 = 1: R9 = R9 + 1
      980 B3 = 0: If I <> VX And J <> VY And I <> QX And J <> QY Then If Rnd(1) > .95 Then B3 = 1: B9 = B9 + 1
1040 G(I, J) = R3 * 1000 + K3 * 100 + B3 * 10 + Int(Rnd * 8 + 1): Next J: Next I
1050 If (K9 + R9) > T9 Then T9 = K9 + R9 + 1

1100 If B9 > 0 Then 1220
1150 If G(Q1, Q2) < 200 Then G(Q1, Q2) = G(Q1, Q2) + 100: K9 = K9 + 1
1160 B9 = 1: G(Q1, Q2) = G(Q1, Q2) + 10
1170 Rem  Q1 = Int(Rnd * 8 + 1): Q2 = Int(Rnd * 8 + 1)
1220 K7 = K9: R7 = R9
1221 Color White: Print "Welcome aboard Captain "; CP$; "!!";
1230 Color Yellow: Print " Your orders are as follows:"
1240 Print "   Destroy the"; K9; "Klingon and"; R9; "Romulan warships which have invaded"
1252 Print "   the galaxy before they can attack federation headquarters"
1260 Print "   on stardate"; T0 + T9; "- this gives you"; T9; "days."
1265 Color White: If B9 = 0 Then Print "There are no starbases."
1267 If B9 = 1 Then Print "There is 1 starbase for resupplying your ship."
1268 If B9 > 1 Then Print "There are"; B9; "starbases for resupplying your ship."
1269 Color Red: Print "There is 1 Vulcan starbase at"; VX; ","; VY
1270 Color Red: Print "There is 1 Ferengi starbase at"; QX; ","; QY
1271 Color White: Print "Press enter to begin game";: Input X$
1272 Rem Color Red: Print "Type ??? For Command List."

1310 Rem This code here any time new quadrant entered.
1320 Z4 = Q1: Z5 = Q2: K3 = 0: R3 = 0: B3 = 0: S3 = 0: G5 = 0: D4 = .5 * Rnd(1): Z(Q1, Q2) = G(Q1, Q2)
1390 If Q1 < 1 Or Q1 > 8 Or Q2 < 1 Or Q2 > 8 Then Q1 = 1: Q2 = 1
1430 GoSub 9030: If T0 <> T Then 1490
1460 Color Yellow: Print "Your mission begins with your starship located"
1470 Print "in the galactic quadrant, '"; G2$; "'.": GoTo 1500
1490 Color White: Print "Now entering "; G2$; " quadrant."
1500 QQ$ = Right$("10000" + LTrim$(Str$(G(Q1, Q2))), 4)
1510 R3 = Int(Val(Mid$(QQ$, 1, 1)) + .5)
1511 K3 = Int(Val(Mid$(QQ$, 2, 1)) + .5)
1520 B3 = Int(Val(Mid$(QQ$, 3, 1)) + .5)
1530 S3 = Int(Val(Mid$(QQ$, 4, 1)) + .5)

1545 If K3 <= 0 And R3 <= 0 Then 1590
1560 Color Red: Print "Combat area      Condition red": If S > 200 Then 1590
1580 Color Yellow: Print "   Shields dangerously low"
1590 For I = 1 To 4: K(I, 1) = 0: K(I, 2) = 0: R(I, 1) = 0: R(I, 2) = 0: Next I
1600 For I = 1 To 4: K(I, 3) = 0: R(I, 3) = 0: Next I: Q$ = Space$(192)
1601 Color White

1660 Rem Position enterprise in quadrant.
1661 Rem Then place 1 Ferengi starbase, 1 Vulcan starbase, R3 Romulans, K3 Klingons,
1670 Rem B3 Starbases, S3 Stars elsewhere.
1680 A$ = "<*>": Z1 = S1: Z2 = S2: GoSub 8670

1719 Rem place klingons in quadrant.
1720 If K3 < 1 Then 1785
1725 For I = 1 To K3: GoSub 8590: A$ = "+++": Z1 = R1: Z2 = R2
1780 GoSub 8670: K(I, 1) = R1: K(I, 2) = R2: K(I, 3) = S9 * (.5 + Rnd(1)): Next I

1781 Rem place romulans in quadrant.
1785 If R3 < 1 Then 1820
1790 For I = 1 To R3: GoSub 8590: A$ = "[+]": Z1 = R1: Z2 = R2
1795 GoSub 8670: R(I, 1) = R1: R(I, 2) = R2: R(I, 3) = S9 * (.5 + Rnd(1)) + 10: Next I

1819 Rem place federation starbase in quadrant.
1820 If B3 < 1 Then 1890
1880 GoSub 8590: A$ = ">!<": Z1 = R1: B4 = R1: Z2 = R2: B5 = R2: GoSub 8670: B0 = 1000

1881 Rem place vulcan starbase in quadrant.
1890 If Q1 = VX And Q2 = VY Then 1892
1891 GoTo 1805
1892 GoSub 8590: A$ = ">*<": Z1 = R1: Z2 = R2: GoSub 8670: ZZ1 = R1: ZZ2 = R2

1894 Rem place ferengi starbase in quadrant.
1805 If Q1 = QX And Q2 = QY Then 1887
1806 GoTo 1910
1887 GoSub 8590: A$ = "***": Z1 = R1: Z2 = R2: GoSub 8670: ZZ3 = R1: ZZ4 = R2

1901 Rem place stars in quadrant.
1910 For I = 1 To S3: GoSub 8590: A$ = " * ": Z1 = R1: Z2 = R2: GoSub 8670: Next I
1980 GoSub 6430

1990 GoSub 9480
1991 If S + E > 10 Then If E > 10 Or D(7) = 0 Then 2050
2000 If S > 0 Then E = E + S: S = 0: Color White: Print "Shield energy diverted to engine.": GoTo 2050
2020 Color Red: Print "** FATAL ERROR ** You've just stranded your ship in space."
2030 Color White: Print "You have insufficient maneuvering energy, and shield control"
2045 Print "is presently incapable of cross-circuiting to engine room!!": GoTo 6220

2050 Color White: Print "Command(???=Help)? ";: Line Input A$: A$ = UCase$(A$)
2051 If Left$(A$, 4) = "SAVE" Then GoTo 2270
2052 If Left$(A$, 4) = "LOAD" Then GoTo 2280
2053 If A$ = "QUIT" Then GoTo 6260
2054 If A$ = "INIT" Then GoSub 9685: GoTo 1990

2061 If InStr(A$, ",") Then GoTo 2110
2062 C1 = Val(A$): If C1 >= 1 And C1 <= 9 Then GoTo 2350

2063 Rem A1$ = "NAVSRSLRSPHATORSHEDAMCOMXXXFIXINC???PHOGENLOCDISSEAHLPINSRATRNDBUYPURLSTEXETOPSAVLOA"
2064 Rem check 28 possible commands.
2065 If Len(A$) = 3 Then
   2066 For I = 1 To 28: If Left$(A$, 3) <> Mid$(A1$, 3 * I - 2, 3) Then 2070
      2067 On I GOTO 2300, 2150, 4000, 4260, 4699, 5530, 5690, 7290, 6260, 5850
      2068 On I - 10 GOTO 5866, 2170, 4680, 6646, 9270, 9352, 9410, 2165, 2165, 2168
      2069 On I - 20 GOTO 2123, 4683, 4689, 9598, 9604, 9850, 2270, 2280
   2070 Next I
2071 End If

2072 Rem process anything after input loop.
2073 If Len(A$) Then Color Yellow: Print "Unknown command."
2074 GoSub 9480

2076 For I = 1 To 9
   2077 If D(I) < 0 Then D(I) = D(I) + .1: If D(I) >= 0 Then R1 = I: GoSub 8790: Color White: Print "Device "; G2$; " repaired."
2078 Next I

2079 If S < 0 Then S = 0
2080 For X1 = 1 To 8: For Y1 = 1 To 8
      2081 A$ = " * ": Z1 = X1: Z2 = Y1: GoSub 8830: If Z3 = 0 Then 2086
      2082 If Rnd(1) <= .99 Then GoTo 2086
      2083 A$ = "   ": Z1 = X1: Z2 = Y1: GoSub 8670: G(Q1, Q2) = G(Q1, Q2) - 1: Z(Q1, Q2) = G(Q1, Q2)
      2084 Color Yellow: Print "Star at sector"; X1; ","; Y1; "just went supernova!": S3 = S3 - 1: If S3 < 0 Then S3 = 0
      2085 GoTo 2090
2086 Next Y1: Next X1

2087 If Rnd(1) < .99 Then GoTo 2130
2088 GoSub 8590: A$ = " * ": Z1 = R1: Z2 = R2: GoSub 8670: If S3 < 8 Then S3 = S3 + 1: G(Q1, Q2) = G(Q1, Q2) + 1: Z(Q1, Q2) = G(Q1, Q2)
2089 Color Yellow: Print "A star was just created at sector"; Z1; ","; Z2: GoTo 1990

2090 Z = 0: For I = 1 To 4: If K(I, 3) <= 0 Then 2092
   2091 K(I, 3) = 0: K3 = K3 - 1: K9 = K9 - 1: Z1 = K(I, 1): Z2 = K(I, 2): A$ = "   ": GoSub 8670: Z = -1
2092 Next I
2093 For I = 1 To 2: If R(I, 3) <= 0 Then 2095
   2094 R(I, 3) = 0: R3 = R3 - 1: R9 = R9 - 1: Z1 = R(I, 1): Z2 = R(I, 2): A$ = "   ": GoSub 8670: Z = -1
2095 Next I: If Z Then Color Red: Print "All enemies in the quadrant were vaporized."
2096 G(Q1, Q2) = B3 * 10 + S3: Z(Q1, Q2) = G(Q1, Q2)
2099 If K9 <= 0 And R9 <= 0 Then 6370

2100 H = 50: Color White: Print H; "Units hit on enterprise.";: S = S - H
2101 If S < 0 Then Color Red: Print " Shields depleted.";: S = 0
2102 Print: If S = 0 Then GoTo 1990
2103 GoTo 2130

2109 Rem specify command course direction and factor.
2110 C1 = Val(Left$(A$, InStr(A$, ",") - 1))
2111 If C1 = 9 Then C1 = 1
2120 W1 = Val(Mid$(A$, InStr(A$, ",") + 1))
2121 If C1 > 0 And C1 < 9 And W1 > 0 Then GoTo 2370
2122 Color Yellow: Print "Lt. " + C1$ + " Reports, 'Incorrect course data, Sir!'": GoTo 1990

2123 C1 = Rnd * 9 + 1: W1 = Rnd * 8 + 1: If C1 >= 9 Then C1 = 1
2124 If D(1) < 0 Then W1 = .2
2125 Z1$ = Str$(C1): If InStr(Z1$, ".") Then Z1$ = Left$(Z1$, InStr(Z1$, ".") + 2)
2126 Z2$ = Str$(W1): If InStr(Z2$, ".") Then Z2$ = Left$(Z2$, InStr(Z2$, ".") + 2)
2128 Color Yellow: Print "Lt. " + C1$ + " reports: Moving course"; Z1$; " warp"; Z2$: GoTo 2380

2129 Rem enemies move and fire on enterprise at random intervals.
2130 CX = CX + 1: If CX = 5 Then GoSub 6207
2131 If CX = 5 Then If D0 = 0 Then If Rnd > .5 Then GoSub 6000
2132 If CX > 5 Then CX = 0: GoTo 1990
2145 GoTo 1990

2149 Rem SRS scan.
2150 GoSub 6650
2155 GoSub 9480
2160 GoTo 1990

2162 Rem help.
2165 GoSub 100044
2166 GoTo 1990

2167 Rem rating
2168 GoSub 9300
2169 GoTo 1990

2170 Color Red: Print "Enter one of the following:"
2180 Color White: Print "  NAV  (Set Course)"
2190 Print "  SRS  (Short Range Sensor Scan)"
2191 Print "  LRS  (Long Range Sensor Scan)"
2192 Print "  PHA  (Fire Phasers)"
2193 Print "  TOR  (Fire Photon Torpedo)"
2194 Print "  SHE  (Raise Or Lower Shields)"
2195 Print "  DAM  (Damage Control Reports)"
2196 Print "  COM  (Call On Library-Computer)"
2197 Print "  FIX  (Repair All Devices)"
2198 Print "  INC  (Increment Device)"
2199 Print "  PHO  (Star Destroyer Torpedo)"
2200 Print "  GEN  (Genesis Device)"
2201 Print "  LOC  (Locate Starbase Coordinates)"
2202 Print "  DIS  (Display Enemies In Galaxy)"
2203 Print "  SEA  (Search Galaxys For Value)"
2204 Print "  HLP/INS  (Display Instructions)"
2205 Color Yellow: Print "Press enter key";: Input X: Color White

2210 Print "  RAT  (Display Captain Rating)"
2211 Print "  BUY  (Purchase Torpedo)"
2212 Print "  PUR  (Purchase Energy)"
2213 Print "  RND  (Random Course)"
2214 Print "  LST  (List Ships Staff)"
2215 Print "  EXE  (Executive Command)"
2216 Print "  TOP  (Display Top 10 Report)"
2217 Print "  SAV  (Save Current Game)"
2218 Print "  LOA  (Load Game Number)"
2220 Print "  XXX  (Resign Your Command)"
2221 Color Yellow: Print "Press enter key";: Input X: Color White: GoTo 1990

2269 Rem save game.
2270 X = 0: If Left$(A$, 4) = "SAVE" Then 2272
2271 GoTo 2276
2272 A$ = LTrim$(Mid$(A$, 5)): If Len(A$) = 0 Then 2276
2273 X = Int(Val(A$) + .5): If X >= 0 And X <= 999 Then GoTo 2275
2274 Print "Invalid game.": GoTo 1990
2275 FX = X: GoSub 9980: Color Yellow: Print "Press enter";: Input X: GoTo 1990
2276 GoSub 9977: Color Yellow: Print "Press enter";: Input X: GoTo 1990

2279 Rem load game.
2280 X = 0: If Left$(A$, 4) = "LOAD" Then 2282
2281 GoTo 2288
2282 A$ = LTrim$(Mid$(A$, 5)): If Len(A$) = 0 Then 2288
2283 X = Int(Val(A$) + .5): If X >= 0 And X <= 999 Then GoTo 2285
2284 Print "Invalid game.": GoTo 1990
2285 FX = X: GoSub 10009: Color Yellow: Print "Press enter";: Input X: GoTo 2289

2288 GoSub 10000: Color Yellow: Print "Press enter";: Input X
2289 If SX = 0 Then GoTo 1320 ' load success
2290 If SX = -1 Then GoTo 250 ' error loading
2291 If SX = -2 Then GoTo 1990 ' ignore load
2292 GoTo 1990

2295 Rem course control begins here.
2300 Color White: Input "Course(1-9)"; C1: If C1 >= 9 Then C1 = 1
2301 If C1 >= 1 Then GoTo 2310

2302 Color Yellow: Print "     Course is in a circular numerical      4  3  2"
2303 Print "     vector arrangement as shown:            \ | /"
2304 Print "     Integer and real values may be            |"
2305 Print "     used.  Thus course 1.5 is half-      5 ---*--- 1"
2306 Print "     way between 1 and 2                       |"
2307 Print "                                             / | \"
2308 Print "     Values may approach 9.0, which         6  7  8"
2309 Print "     itself is equivalent to 1.0": GoTo 2300

2310 If C1 >= 1 And C1 < 9 Then 2350
2330 Color Red: Print "Lt. " + C1$ + " reports, 'Incorrect course data, Sir!'": GoTo 1990
2350 If C1 >= 9 Then C1 = 1

2351 X$ = "8": If D(1) < 0 Then X$ = "0.2"
2360 Color White: Print "Warp factor(0-"; X$; ")";: Input W1
2370 If D(1) < 0 And W1 > .2 Then 2470
2380 If W1 > 0 And W1 <= 8 Then 2490
2390 If W1 = 0 Then 1990
2420 Color Yellow: Print "Chief Engineer " + C3$ + " reports 'The engines won't take warp "; W1; "!'": GoTo 1990
2470 Color Yellow: Print "Warp engines are damaged. Maximum impulse speed = Warp 0.2": GoTo 1990
2490 N = Int(W1 * 8 + .5): If E - N >= 0 Then 2750
2500 Color Yellow: Print "Engineering reports 'Insufficient energy available"
2510 Print " for maneuvering at warp"; W1; "!'"
2530 If S < N - E Or D(7) < 0 Then 1990
2550 Color Red: Print "Mr. " + C4$ + " Reports 'Deflector control room acknowledges"; S; "units of energy'."
2560 Print " presently deployed to shields."
2570 GoTo 1990

2580 Rem Romulans move/Klingons mave/Fire on moving starship.
2750 GoSub 6207: GoSub 6000: D1 = 0: D6 = W1: If W1 >= 1 Then D6 = 1

2770 For I = 1 To 9: If D(I) >= 0 Then 2880
   2790 D(I) = D(I) + D6: If D(I) > -.1 And D(I) < 0 Then D(I) = -.1: GoTo 2880
   2800 If D(I) < 0 Then 2880
   2810 If D1 <> 1 Then D1 = 1: Print "Damage control report: ";
   2840 R1 = I: GoSub 8790: Print G2$; " Repair completed."
2880 Next I: If Rnd(1) > .2 Then 3070
2910 R1 = Int(Rnd * 9 + 1): If Rnd(1) >= .6 Then 3000
2930 D(R1) = D(R1) - (Rnd(1) * 5 + 1): Print "Damage control report: ";
2960 GoSub 8790: Print G2$; " damaged.": GoTo 3070
3000 D(R1) = D(R1) + Rnd(1) * 3 + 1: Print "Damage control report: ";
3030 GoSub 8790: Print G2$; " state of repair improved.": Print
3060 Rem Begin moving starship.
3070 A$ = "   ": Z1 = Int(S1): Z2 = Int(S2): GoSub 8670
3110 X1 = C(C1, 1) + (C(C1 + 1, 1) - C(C1, 1)) * (C1 - Int(C1)): X = S1: y = S2
3140 X2 = C(C1, 2) + (C(C1 + 1, 2) - C(C1, 2)) * (C1 - Int(C1)): Q4 = Q1: Q5 = Q2
3170 For I = 1 To N: S1 = S1 + X1: S2 = S2 + X2: If S1 < 1 Or S1 >= 9 Or S2 < 1 Or S2 >= 9 Then 3500
   3240 S8 = Int(S1) * 24 + Int(S2) * 3 - 26: If Mid$(Q$, S8, 3) = "   " Then 3360
   3320 S1 = Int(S1 - X1): S2 = Int(S2 - X2): Print "Warp engines shut down at ";
   3350 Print "Sector"; S1; ","; S2; "due to bad navigation."
   3351 Color Red: QQ$ = Mid$(Q$, S8, 3): If QQ$ = " * " Then Print "You ran into a star."
   3352 If QQ$ = "+++" Then Print "You ran into a Klingon."
   3353 If QQ$ = "[+]" Then Print "You ran into a Romulan."
   3354 If QQ$ = ">!<" Then Print "You ran into a Federation Starbase."
   3355 If QQ$ = ">*<" Then Print "You ran into a Vulcan Starbase."
   3356 If QQ$ = "***" Then Print "You ran into a Ferengi Starbase."
   3357 If QQ$ = " - " Or QQ$ = " + " Then Print "You ran into a peice of debris."
   3358 Color White: GoTo 3370
3360 Next I: S1 = Int(S1): S2 = Int(S2)
3370 A$ = "<*>": Z1 = Int(S1): Z2 = Int(S2): GoSub 8670: GoSub 3910: T8 = 1
3430 If W1 < 1 Then T8 = .1 * Int(10 * W1)
3450 T = T + T8: If T > T0 + T9 Then 6220

3470 Rem See if docked, then get command.
3480 GoTo 1980

3490 Rem Exceeded quadrant limits.
3500 X = 8 * Q1 + X + N * X1: y = 8 * Q2 + y + N * X2: Q1 = Int(X / 8): Q2 = Int(y / 8): S1 = Int(X - Q1 * 8)
3550 S2 = Int(y - Q2 * 8): If S1 = 0 Then Q1 = Q1 - 1: S1 = 8
3590 If S2 = 0 Then Q2 = Q2 - 1: S2 = 8
3620 X5 = 0: If Q1 < 1 Then X5 = 1: Q1 = 1: S1 = 1
3670 If Q1 > 8 Then X5 = 1: Q1 = 8: S1 = 8
3710 If Q2 < 1 Then X5 = 1: Q2 = 1: S2 = 1
3750 If Q2 > 8 Then X5 = 1: Q2 = 8: S2 = 8
3790 If X5 = 0 Then 3860
3800 Color Yellow: Print "Lt. " + C2$ + " reports message from Starfleet Command:"
3810 Print "  'Permission to attempt crossing of galactic perimeter"
3820 Print "  is hereby *DENIED*.  Shut down your engines.'"
3830 Print "Chief Engineer " + C3$ + " reports  'Warp engines shut down"
3840 Print "  at quadrant"; Q1; ","; Q2; "sector"; S1; ","; S2; "'"
3845 Color White: Print "Press key";: Input X$
3850 If T > T0 + T9 Then 6220
3860 If 8 * Q1 + Q2 = 8 * Q4 + Q5 Then 3370
3870 T = T + 1: GoSub 3910: GoTo 1320
3900 Rem Maneuver energy.
3910 E = E - N - 10: If E >= 0 Then Return
3930 Print "Shield control supplies energy to complete the maneuver."
3940 S = S + E: E = 0: If S <= 0 Then S = 0
3980 Return

3990 Rem Long range sensor scan code.
4000 If D(3) < 0 Then Color Red: Print "Long range sensors are inoperable.": GoTo 1990
4030 Print "Long range scan for quadrant"; Q1; ","; Q2
4040 Color White: O1$ = String$(19, "-"): Print O1$
4060 For I = Q1 - 1 To Q1 + 1: N(1) = -1: N(2) = -2: N(3) = -3: For J = Q2 - 1 To Q2 + 1
      4120 If I > 0 And I < 9 And J > 0 And J < 9 Then N(J - Q2 + 2) = G(I, J): Z(I, J) = G(I, J)
      4180 Next J: For l = 1 To 3: Color White: Print ":";: If N(l) < 0 Then Color Yellow: Print "**** ";: GoTo 4230
      4210 Color Yellow: Print Right$(Str$(N(l) + 10000), 4); " ";
4230 Next l: Color White: Print ":": Print O1$: Next I: GoTo 1990

4250 Rem Phaser control code begins here.
4260 If D(4) < 0 Then Color Red: Print "Phasers inoperative": GoTo 1990
4262 GoSub 7262 ' delete debris.
4265 If K3 > 0 Or R3 > 0 Then 4330
4270 Color Yellow: Print "Science officer " + C4$ + " reports 'Sensors show no enemy ships in this quadrant'": GoTo 1990
4330 If D(8) < 0 Then Color Red: Print "Computer failure hampers accuracy"
4440 If D0 = 3 Then Print "Phasers locked on target.": GoTo 4370
4350 Color White: Print "Phasers locked on target; Energy available ="; E; "units"
4370 Input "Number of units to fire"; X: X = Int(X): If X <= 0 Then 1990
4380 Z = 0: Z1 = 0: Z2 = 0
4390 For I = 1 To 4
   4391 If K(I, 3) > 0 Then Z = Z + 1: Z1 = Z1 + 1
4392 Next I
4393 For I = 1 To 2
   4394 If R(I, 3) > 0 Then Z = Z + 1: Z2 = Z2 + 1
4395 Next I
4397 If Z = 0 Then Print "No ships in quadrant.": GoTo 1990
4398 If D0 = 3 Then Print "Ferengis payed the cost of the phasers.": GoTo 4401
4400 If E - X < 0 Then Print "Not enough energy remaining.": GoTo 1990
4401 X1$ = "": X2$ = "": If Z1 > 1 Then X1$ = "S"
4402 If Z2 > 1 Then X2$ = "S"
4403 If Z1 > 0 And Z2 > 0 Then Print "Firing on"; Z1; "Klingon"; X1$; " and"; Z2; "Romulan" + X2$ + "."
4404 If Z1 > 0 And Z2 = 0 Then Print "Firing on"; Z1; "Klingon"; X1$; "."
4405 If Z1 = 0 And Z2 > 0 Then Print "Firing on"; Z2; "Romulan"; X2$; "."
4406 If D0 = 3 Then 4408
4407 E = E - X
4408 If D(8) < 0 Then X = X * Rnd(1) + 10
4450 H1 = Int(X / (K3 + R3)): For K = 1 To 2: For I = 1 To 4
      4451 If K = 2 And I > 2 Then GoTo 4670
      4452 If K = 1 Then If K(I, 3) <= 0 Then 4670
      4453 If K = 1 Then If K(I, 1) = 0 And K(I, 2) = 0 Then GoTo 4670
      4454 If K = 2 Then If R(I, 1) = 0 And R(I, 2) = 0 Then GoTo 4670
      4455 If K = 2 Then If I <= 2 Then If R(I, 3) <= 0 Then 4670
      4460 If K = 1 Then Z = Sqr((K(I, 1) - S1) ^ 2 + (K(I, 2) - S2) ^ 2)
      4470 If K = 2 Then Z = Sqr((R(I, 1) - S1) ^ 2 + (R(I, 2) - S2) ^ 2)
      4480 H = Int((H1 / Z) * (Rnd(1) + 2)): If H > .15 * K(I, 3) Then 4520
      4500 If K = 1 Then Print "Sensors show no damage to Klingon at "; K(I, 1); ","; K(I, 2): GoTo 4670
      4510 If K = 2 Then Print "Sensors show no damage to Romulan at "; R(I, 1); ","; R(I, 2): GoTo 4670
      4520 If K = 1 Then K(I, 3) = K(I, 3) - H: Print H; "units hit on Klingon at sector"; K(I, 1); ","; K(I, 2)
      4530 If K = 2 Then R(I, 3) = R(I, 3) - H: Print H; "units hit on Romulan at sector"; R(I, 1); ","; R(I, 2)
      4550 If K = 1 Then If K(I, 3) <= 0 Then Color Red: Print "*** KLINGON DESTROYED ***": Color White: GoTo 4580
      4555 If K = 2 Then If R(I, 3) <= 0 Then Color Red: Print "*** ROMULAN DESTROYED ***": Color White: GoTo 4580
      4560 If K = 1 Then Print "   (sensors show"; Int(K(I, 3)); "Klingon units remaining)": GoTo 4670
      4570 If K = 2 Then Print "   (sensors show"; Int(R(I, 3)); "Romulan units remaining)": GoTo 4670
      4580 If K = 1 Then K3 = K3 - 1: K9 = K9 - 1: Z1 = K(I, 1): Z2 = K(I, 2): A$ = "   ": GoSub 8670: GoSub 5962
      4581 If K = 2 Then R3 = R3 - 1: R9 = R9 - 1: Z1 = R(I, 1): Z2 = R(I, 2): A$ = "   ": GoSub 8670: GoSub 5962
      4585 XX = XX + 1: P = P + 2: Print "Mr. " + C4$ + " reports: 'Torpedoes now"; P;: E = E + 100: Print "Energy now"; E; "'"
      4650 If K = 1 Then K(I, 3) = 0: G(Q1, Q2) = G(Q1, Q2) - 100: Z(Q1, Q2) = G(Q1, Q2): If K9 <= 0 And R9 <= 0 Then 6370
      4655 If K = 1 Then GoTo 4670
      4656 If K = 2 Then R(I, 3) = 0: If G(Q1, Q2) - 1000 < 0 Then 4661
      4660 If K = 2 Then G(Q1, Q2) = G(Q1, Q2) - 1000
      4661 If K = 2 Then Z(Q1, Q2) = G(Q1, Q2): If K9 <= 0 And R9 <= 0 Then 6370
4670 Next I: Next K: GoSub 6000: GoTo 1990

4675 Rem Star photon torpedo code begins here.
4680 If D(9) < 0 Then Color Red: Print "Star Destroyer Torpedoes are inoperable.": GoTo 1990
4681 Q = -1: If P1 > 0 Then 4760
4682 Print "All Photonic Star Destroyer Torpedoes used.": GoTo 1990

4683 If D0 <= 1 Then Print "Not docked to Ferengi or Vulcan Starbase.": GoTo 1990
4684 If D0 = 3 Then 4686
4685 If Cash - 100 < 0 Then Print "The Enterprise does not have enough credits.": GoTo 1990
4686 P1 = P1 + 2: If D0 = 2 Then Cash = Cash - 100
4687 Color Yellow: Print "Photonic Star Destroyer Torpedoes increased to"; P1: If D0 = 3 Then Print "The Ferengis gave them for free.": GoTo 1990
4688 Print "You now have"; Cash; "credits remaining.": GoTo 1990

4689 If D0 <= 1 Then Print "Not docked to Ferengi or Vulcan Starbase.": GoTo 1990
4690 If D0 = 3 Then 4693
4691 If Cash - 100 < 0 Then Print "The Enterprise does not have enough credits.": GoTo 1990
4693 E = E + 1000: If D0 = 2 Then Cash = Cash - 100
4694 Color Yellow: Print "Energy increased to"; Str$(E); " units.": If D0 = 3 Then Print "The Ferengis gave them for free.": GoTo 1990
4695 Print "You now have"; Cash; "credits remaining.": GoTo 1990

4698 Rem Photon torpedo code begins here.
4699 Q = 0
4700 If P <= 0 Then Print "All photon torpedoes expended": GoTo 1990
4730 If D(5) < 0 Then Color Red: Print "Photon tubes are not operational.": GoTo 1990
4760 Color Yellow: Input "Photon torpedo course(1-9)"; C1: If C1 = 9 Then C1 = 1
4780 If C1 >= 1 And C1 < 9 Then 4850
4790 Print "Ensign " + Names$(6) + " reports, 'Incorrect course data, Sir!'": GoTo 1990
4850 If Q = -1 Then Print "Photonic Star Destroyer initiated."
4855 X1 = C(C1, 1) + (C(C1 + 1, 1) - C(C1, 1)) * (C1 - Int(C1)): E = E - 2
4860 X2 = C(C1, 2) + (C(C1 + 1, 2) - C(C1, 2)) * (C1 - Int(C1)): X = S1: y = S2
4870 If Q = 0 Then P = P - 1
4880 If Q = -1 Then P1 = P1 - 1
4910 Color Yellow: Print "Torpedo track:": Color White
4920 X = X + X1: y = y + X2: X3 = Int(X + .5): Y3 = Int(y + .5)
4960 If X3 < 1 Or X3 > 8 Or Y3 < 1 Or Y3 > 8 Then 5490
5000 Color Red: Print "   "; X3; ","; Y3: Color White: A$ = "   ": Z1 = X: Z2 = y: GoSub 8830
5050 If Z3 <> 0 Then 4920

5060 A$ = "+++": Z1 = X: Z2 = y: GoSub 8830: If Z3 = 0 Then 5191
5110 Color Red: XX = XX + 1: Print "*** KLINGON DESTROYED ***": Color White: K3 = K3 - 1: K9 = K9 - 1: If K9 <= 0 And R9 <= 0 Then 6370
5150 For I = 1 To 4: If X3 = K(I, 1) And Y3 = K(I, 2) Then 5190
5180 Next I: GoTo 5191
5190 K(I, 3) = 0: P = P + 2: Print "Mr. " + C4$ + " reports 'Torpedoes now"; P;: E = E + 100: Print "Energy now"; E; "'": GoTo 5430

5191 A$ = "[+]": Z1 = X: Z2 = y: GoSub 8830: If Z3 = 0 Then 5210
5192 Color Red: XX = XX + 1: Print "*** ROMULAN DESTROYED ***": Color White: R3 = R3 - 1: R9 = R9 - 1: If K9 <= 0 And R9 <= 0 Then 6370
5193 For I = 1 To 2: If X3 = R(I, 1) And Y3 = R(I, 2) Then 5195
5194 Next I: GoTo 5210
5195 R(I, 3) = 0: P = P + 2: Print "Mr. " + C4$ + " reports 'Torpedoes now"; P;: E = E + 100: Print "Energy now"; E; "'": GoTo 5430

5210 A$ = " - ": Z1 = X: Z2 = y: GoSub 8830: If Z3 = 0 Then 5212
5211 A$ = "   ": Z1 = X: Z2 = y: GoSub 8670: Print "Peice of debris deleted.": GoTo 1990
5212 A$ = " + ": Z1 = X: Z2 = y: GoSub 8830: If Z3 = 0 Then 5215
5213 A$ = "   ": Z1 = X: Z2 = y: GoSub 8670: Print "Peice of debris deleted.": GoTo 1990

5215 A$ = " * ": Z1 = X: Z2 = y: GoSub 8830: If Z3 = 0 Then 5278
5260 If Q = 0 Then Print "Star at"; X3; ","; Y3; "absorbed torpedo energy.": GoSub 6000: GoTo 1990

5270 A$ = "   ": Z1 = X: Z2 = y: GoSub 8670: GoSub 5962: G(Q1, Q2) = G(Q1, Q2) - 1: Z(Q1, Q2) = G(Q1, Q2)
5274 Color White: Print "Star at"; Z1; ","; Z2;: Color Red: Print "obliterated.": S3 = S3 - 1: If S3 < 0 Then S3 = 0
5275 If S3 > 0 Then GoTo 1990
5276 Color Red: Print "Captain "; CP$; "! You have destroyed all the stars in the quadrant!"
5277 Color Magenta: Print "Doctor " + C5$ + " Declares you are unfit for command!": Color White: GoTo 6270

5278 A$ = ">*<": Z1 = X: Z2 = y: GoSub 8830: If Z3 = 0 Then 5280
5279 Color Yellow: Print "Torpedo has no effect on Vulcan Starbase.": Color White: GoTo 1990

5280 A$ = "***": Z1 = X: Z2 = y: GoSub 8830: If Z3 = 0 Then 5285
5281 Color Yellow: Print "Torpedo has no effect on Ferengi Starbase.": Color White: GoTo 1990

5285 A$ = ">!<": Z1 = X: Z2 = y: GoSub 8830: If Z3 = 0 Then 1990
5290 B0 = B0 - 100: If B0 <= 0 Then 5330
5291 Color Yellow: Print "Starbase absorbed torpedo energy."
5292 Color White: Print "   Starbase shields now"; B0; "units.": GoTo 1990
5330 Color Red: XX = XX + 1: Print "*** STARBASE DESTROYED ***": B3 = B3 - 1: B9 = B9 - 1: Color White
5360 If B9 > 0 Or K9 > T - T0 - T9 Then 5400
5370 If B9 = 0 Then Print "You destroyed all the Starbases."
5375 Color Magenta: Print "That does it, Captain "; CP$; "!! You are hereby relieved of command"
5380 Print "and sentenced to 99 stardates at hard labor on CYGNUS 12!!": Color White
5390 GoTo 6270
5400 If B9 = 0 Then Color Yellow: Print "You destroyed all the Starbases."
5401 Color White: Print "Starfleet Command reviewing your record to consider court martial!": D0 = 0
5430 Z1 = X: Z2 = y: A$ = "   ": GoSub 8670: GoSub 5962
5470 G(Q1, Q2) = R3 * 1000 + K3 * 100 + B3 * 10 + S3: Z(Q1, Q2) = G(Q1, Q2): GoSub 6000: GoTo 1990
5490 Color Yellow: Print "Torpedo missed.": Color White: GoSub 6000: GoTo 1990

5520 Rem Shield control.
5530 If D(7) < 0 Then Color Red: Print "Shield control inoperable.": GoTo 1990
5540 Color Yellow: If D0 > 0 Then Print "Cannot set shields when docked.": GoTo 1990
5560 Print "Energy available ="; E + S: Input "Number of units to shields"; X
5580 If X < 0 Or S = X Then Print "<shields unchanged>": GoTo 1990
5590 If X <= E + S Then 5630
5600 Print "Shield control reports  'This is not the Federation treasury.'"
5610 Print "<shields unchanged>": GoTo 1990
5630 E = E + S - X: S = X: Print "Mr. " + C4$ + " Reports: Deflector control room report:"
5631 Print "  'Shields now at"; Int(S); "units per your command.'": GoTo 1990

5632 Rem Ferengi/Vulcan starbase repairs all devices.
5833 Z = 0: X = 0: For I = 1 To 9: If D(I) < 0 Then X = -1
5834 Next I: If X = 0 Then Return
5835 For I = 1 To 9: If D(I) < 0 Then D(I) = 0: Z = Z + 1
5836 Next I: If D0 = 2 Then Print "Vulcan Starbase repaired all devices.": Return
5837 If D0 = 3 Then Print "Ferengi Starbase repaired all devices.": Return
5838 Print "All devcies repaired.": Return

5841 Rem backup computer repairs all devices.
5645 Color Green: Print "Failsafe attempting to repair all devices."

5646 Rem fix commmand repairs all devices.
5850 Z = 0: X = 0: For I = 1 To 9: If D(I) < 0 Then X = -1
5851 Next I: If X = 0 Then Color Red: Print "No damaged devices.": GoTo 1990
5852 Color Yellow: If D0 > 0 Then Print "Starbase effects repairs.": X = 0: GoTo 5854
5853 X = 100: If E - X < 0 Then Print "Not enough energy to repair.": GoTo 1990
5854 For I = 1 To 9: If D(I) < 0 Then D(I) = 0: Z = Z + 1
5855 Next I: Color Yellow: Print "Total"; Z; "devices repaired.": E = E - X
5856 If D0 = 0 Then Print "Mr. " + C4$ + " reports 'Energy now"; E; "'"
5857 GoTo 1990

5865 Rem increnemnt device.
5866 Input "Enter device(1-9)"; I
5868 If I >= 1 And I <= 9 Then GoTo 5670
5869 Color Red: Print "Invalid device.": GoTo 1990
5670 Color Yellow: Print "Increment amount(1-9)";: Input Z
5671 If Z >= 1 And Z <= 9 Then GoTo 5673
5672 Color Red: Print "Invalid amount.": GoTo 1990
5673 Color Yellow: If D(I) >= 10 Then Print "Device already has 10 units.": GoTo 1990
5674 If D0 > 0 Then Print "Starbase effects repairs.": D(I) = D(I) + Z * .1: GoTo 1990
5675 X = 10 * Z: If E - X < 0 Then Print "Not enough energy to repair.": GoTo 1990
5676 D(I) = D(I) + Z * .1: E = E - X
5677 R1 = I: GoSub 8790: Print "Device "; G2$; " incremented.": Print "Mr. " + C4$ + " reports 'Energy now"; E; "'": GoTo 1990

5685 Rem Damage control.
5690 If D0 <> 0 Then 5720 ' check docked
5695 If D(6) >= 0 Then 5720 ' check damage control damaged
5700 Color Red: Print "Damage control report not available": GoTo 1990
5720 D3 = 0: For I = 1 To 9: If D(I) < 0 Then D3 = D3 + .1
5760 Next I: If D3 = 0 Then 5910
5780 D3 = D3 + D4: If D3 >= 1 Then D3 = .9
5810 Color Yellow: Print "Technicians standing by to effect repairs to your ship;"
5820 Print "Estimated time to repair:"; .01 * Int(100 * D3); "stardates"
5840 Input " Will you authorize the repair order(Y/N)"; A$: A$ = UCase$(A$)
5860 If A$ = "Y" Then Print "Mr. " + C4$ + " reports: 'repair in effect'": GoTo 5870
5861 GoTo 5910
5870 For I = 1 To 9: If D(I) < 0 Then D(I) = 0
5890 Next I: T = T + D3 + .1: Color White: Print "Devices repaired."
5910 O1$ = String$(40, "-"): Color White: Print "Device               State of repair": Print O1$: Z1 = 0: Z2 = 0
5915 For R1 = 1 To 9
   5920 GoSub 8790: Color Yellow: Print G2$; Left$(Z$, 25 - Len(G2$));
   5930 Z = Int(D(R1) * 100) * .01
   5931 If Z < 0 Then Color Red: Print "(damaged)";: Z1 = -1
   5932 If Z = 0 Then Color Magenta: Print "(normal)";
   5933 If Z > 0 Then Color Blue: Print "(healthy)";: Z2 = Z2 + 1
   5934 Print
5950 Next R1
5955 Color White: If Z1 = 0 Then Print "All devices report normal.";
5956 If Z2 > 0 Then Print Z2; "healthy.";
5957 Print
5960 GoTo 1990

5961 Rem add debris.
5962 X = 0: QZ1 = Z1: QZ2 = Z2: For I2 = QZ1 - 1 To QZ1 + 1: For J2 = QZ2 - 1 To QZ2 + 1
      5963 If I2 < 1 Or I2 > 8 Or J2 < 1 Or J2 > 8 Then 5998
      5964 If Rnd > .5 Then 5998
      5965 Z1 = I2: Z2 = J2
      5966 A$ = "   ": GoSub 8830: If Z3 = 0 Then 5998
      5967 If Rnd > .5 Then A$ = " + " Else A$ = " - "
      5969 GoSub 8670: X = X + 1: If X >= 3 Then Return
5998 Next J2: Next I2: Return

5999 Rem Klingons/Romulans fire on Enterprise.
6000 If K3 <= 0 And R3 <= 0 Then Return
6010 If D0 = 1 Then Print "Federation Starbase shields protect the Enterprise.": Return
6020 If D0 = 2 Then Print "Vulcan Starbase shields protect the Enterprise.": Return
6030 If D0 = 3 Then Print "Ferengi Starbase shields protect the Enterprise.": Return
6040 For K = 1 To 2: For I = 1 To 4: If K = 2 And I > 2 Then 6200
      6041 If K = 1 Then If K(I, 3) <= 0 Then 6200
      6042 If K = 2 Then If I <= 2 Then If R(I, 3) <= 0 Then 6200
      6050 If K = 1 Then Z = Sqr((K(I, 1) - S1) ^ 2 + (K(I, 2) - S2) ^ 2)
      6051 If K = 2 Then Z = Sqr((R(I, 1) - S1) ^ 2 + (R(I, 2) - S2) ^ 2)
      6060 If K = 1 Then H = Int((K(I, 3) / Z) * (2 + Rnd(1))): K(I, 3) = K(I, 3) / (3 + Rnd(0))
      6061 If K = 2 Then H = Int((R(I, 3) / Z) * (2 + Rnd(1))): R(I, 3) = R(I, 3) / (3 + Rnd(0))
      6062 If H > 100 Then GoTo 6200
      6080 If K = 1 Then Print H; "units hit on Enterprise from sector"; K(I, 1); ","; K(I, 2): S = S - H
      6081 If K = 2 Then Print H; "units hit on Enterprise from sector"; R(I, 1); ","; R(I, 2): S = S - H
      6090 If S > 0 Then 6100
      6091 Print "Shields depleted. Deathly damage. Press enter";: Input ZZ
      6092 GoTo 6240
      6100 Print "   <shields down to"; S; "units>": If H < 20 Then 6200
      6120 If Rnd(1) > .6 Or H / S <= .02 Then 6200
      6140 R1 = Int(Rnd * 9 + 1): D(R1) = D(R1) - H / S - .5 * Rnd(1): GoSub 8790

      6145 Rem Damage control cannot report damage control damaged if damage control damaged!
      6150 If D(6) < 0 Then GoTo 6200
      6170 If R1 <> 6 Then Print "Damage control reports "; G2$; " damaged by the hit!"
6200 Next I: Next K
6201 Z = 0: For A = 1 To 9: If D(A) >= 0 Then Z = -1
6202 Next A: If Z <> 0 Then GoTo 6204
6203 If Z = 0 Then Print "WARNING! Backup computer reports all devices damaged!": Return 5645
6204 Return

6206 Rem Move romulans and klingons.
6207 For I = 1 To K3: If K(I, 3) <= 0 Then 6210
   6208 A$ = "   ": Z1 = K(I, 1): Z2 = K(I, 2): GoSub 8670: GoSub 8590
   6209 K(I, 1) = Z1: K(I, 2) = Z2: A$ = "+++": GoSub 8670
6210 Next I
6211 For I = 1 To R3: If R(I, 3) <= 0 Then 6214
   6212 A$ = "   ": Z1 = R(I, 1): Z2 = R(I, 2): GoSub 8670: GoSub 8590
   6213 R(I, 1) = Z1: R(I, 2) = Z2: A$ = "[+]": GoSub 8670
6214 Next I: Return

6220 Print "It is Stardate"; T: GoTo 6270
6240 Print "The Enterprise has been destroyed!"
6250 Print "The Federation will be conquered!": GoTo 6220
6260 GoSub 9300

6270 Print "There were"; K9; "Klingon and"; R9; "Romulan battle cruisers left at"
6280 Print "the end of your mission."
6290 Print: If B9 = 0 Then GoTo 10001231

6310 Print "The Federation is in need of a new Starship Commander"
6320 Print "for a similar mission -- if there is a volunteer,"
6330 Input "let him step forward and enter 'AYE'"; A$: A$ = UCase$(A$): If A$ = "AYE" Then 6365
6331 Color Red: Print "Game ended.": GoTo 10001231

6365 Print "Press enter to restart game";: Input X: GoTo 250

6366 Rem mission succeeded.
6370 Print "Congratulation, Captain "; CP$; "! The last enemy battle cruiser"
6380 Print "menacing the Federation has been destroyed!": Print
6415 GoSub 9300: GoTo 6290

6420 Rem Short range sensor scan & startup subroutine.
6430 For I = S1 - 1 To S1 + 1: For J = S2 - 1 To S2 + 1
      6450 If I < 1 Or I > 8 Or J < 1 Or J > 8 Then 6540
      6455 Rem federation starbase.
      6490 A$ = ">!<": Z1 = I: Z2 = J: GoSub 8830: If Z3 = 1 Then 6580
      6494 Rem vulcan starbase.
      6495 A$ = ">*<": Z1 = I: Z2 = J: GoSub 8830: If Z3 = 1 Then 6625
      6496 Rem ferengi starbase.
      6497 A$ = "***": Z1 = I: Z2 = J: GoSub 8830: If Z3 = 1 Then 6551
6540 Next J: Next I: D0 = 0: GoTo 6650

6550 Rem docked to ferengi starbase. seems as such that Ferengis give stuff away for free!
6551 D0 = 3: C$ = "DOCKED": E = E0: If P < P0 Then P = P0
6552 Color Yellow: Print "Shields dropped for docking purpopses.": E = E + S: S = 0: Color White: GoSub 5833
6553 Cash = Cash + 1200: Color Red: Print "Credits increased to"; Cash: Color White
6554 If P1 < 10 Then P1 = 10: Color Yellow: Print "Photonic Star Destroyer Torpedoes restocked.": Color White
6555 If G1 = 0 Then Color Yellow: Print "Ferengi Starbase sends you a new Genesis Device.": G1 = 1
6556 Color White: GoTo 6720

6579 Rem docked to federation starbase.
6580 D0 = 1: C$ = "DOCKED": E = E0: If P < P0 Then P = P0
6620 Color Yellow: Print "Shields dropped for docking purpopses.": E = E + S: S = 0: Color White: GoTo 6630

6624 Rem docked to vulcan starbase.
6625 D0 = 2: C$ = "DOCKED": E = E0: If P < P0 Then P = P0
6626 Color Yellow: Print "Shields dropped for docking purposes.": E = E + S: S = 0: Color White: GoSub 5833
6627 Cash = Cash + 1000: Color Red: Print "Credits increased to"; Cash: Color White: GoTo 6720

6630 If P1 < 10 Then P1 = 10: Color Yellow: Print "Photonic Star Destroyer Torpedoes restocked.": Color White
6640 If Rnd(1) > .5 Then GoTo 6720
6641 Color Yellow: If Q9 < 4 Then Q9 = Q9 + 1: QQ = Int(Rnd(1) * 3 + 2): T9 = T9 + QQ: Print "Starfleet Command extends your mission by"; QQ; "stardates."
6642 If G1 = 0 Then Color Yellow: Print "Federation Starbase sends you a new Genesis Device.": G1 = 1
6645 Color White: GoTo 6720

6646 If G1 = 0 Then Color Yellow: Print "Genesis Device already used.": GoTo 1990
6647 If S3 >= 8 Then Color Yellow: Print "Error creating star. Maximum of 8 stars already exist.": GoTo 1990
6648 GoSub 8590: A$ = " * ": Z1 = R1: Z2 = R2: GoSub 8670: S3 = S3 + 1: G1 = 0
6649 Color Red: Print "Genesis Device initiated. A star was just created at sector"; Z1; ","; Z2: G(Q1, Q2) = G(Q1, Q2) + 1: Z(Q1, Q2) = G(Q1, Q2): GoTo 1990

6650 If R3 > 0 Or K3 > 0 Then C$ = "*RED*": GoTo 6720
6660 C$ = "GREEN": If E < E0 * .1 Then C$ = "YELLOW"
6720 If D(2) >= 0 Then 6770
6730 Color Red: Print "*** Short Range Sensors Are Out ***": Return
6770 G5 = 0: GoSub 9030
6771 Color White: Print "SRS scan for: "; G2$; " Quadrant"; Q1; ","; Q2; "Sector"; S1; ","; S2
6772 O1$ = String$(33, "-"): Print O1$
6773 For I = 1 To 8
   6820 For J = (I - 1) * 24 + 1 To (I - 1) * 24 + 22 Step 3
      6821 I$ = Mid$(Q$, J, 3): Color White, 0: Print " ";
      6822 If I$ = " * " Then Color Yellow
      6823 If I$ = "+++" Then Color Red
      6824 If I$ = "[+]" Then Color Magenta
      6825 If I$ = "<*>" Then Color White
      6826 If I$ = ">!<" Or I$ = ">*<" Or I$ = "***" Then Color White, 1
      6827 If I$ = " - " Or I$ = " + " Then Color Blue
      6828 Print I$;
   6829 Next J
   6830 Color White, 0
   6840 On I GOTO 6850, 6900, 7070, 7120, 7180, 7240, 7245, 7246
   6850 Print "    STARDATE          "; Int(T * 10) * .1;
   6851 Color Yellow: Print " (Stars"; Str$(S3); ")": GoTo 7260
   6900 Print "    CONDITION          ";
   6901 If C$ = "GREEN" Then Color Green
   6902 If C$ = "YELLOW" Then Color Yellow
   6903 If C$ = "*RED*" Then Color Red
   6904 If C$ = "DOCKED" Then Color Magenta

   6910 Print C$: GoTo 7260

   7070 Print "    PHOTON TORPEDOES  "; Int(P): GoTo 7260
   7120 Print "    TOTAL ENERGY      "; Int(E + S): GoTo 7260
   7180 Print "    SHIELDS           "; Int(S): GoTo 7260
   7240 Print "    KLINGONS/ROMULANS "; Int(K9); "/"; Int(R9); "Remaining": GoTo 7260

   7245 Print "    STAR TORPEDOES    "; P1: GoTo 7260
   7246 Print "    GENESIS DEVICE     ";: If G1 Then Color Green: Print "Active" Else Color Yellow: Print "Deactive"
7260 Next I: Print O1$: Return

7261 Rem delete debris.
7262 Z = 0: For I2 = 1 To 8: K2 = 0
   7263 For J2 = (I2 - 1) * 24 + 1 To (I2 - 1) * 24 + 22 Step 3: K2 = K2 + 1
      7274 I$ = Mid$(Q$, J2, 3)
      7275 If I$ = " - " Or I$ = " + " Then GoTo 7277
      7276 GoTo 7278
      7277 A$ = "   ": Z1 = I2: Z2 = K2: GoSub 8670: Z = Z + 1
7278 Next J2: Next I2: If Z Then Color Yellow: Print "Total of"; Z; "peices of debris deleted."
7279 Return

7280 Rem Library computer code.
7290 If D(8) < 0 Then Color Red: Print "Computer disabled.": GoTo 1990
7320 Color Yellow: Input "Computer active and awaiting command"; A: If A < 0 Then 1990
7350 Color White: H8 = 1: On A GOTO 7543, 7900, 8070, 8500, 8150, 7400, 1990
7360 Color White: Print "Functions available from Library-Computer:"
7370 Print "   1 = Cumulative Galactic Record"
7372 Print "   2 = Status Report"
7374 Print "   3 = Photon Torpedo Data"
7376 Print "   4 = Starbase Nav Data"
7378 Print "   5 = Direction/Distance Calculator"
7380 Print "   6 = Galaxy 'Region Name' Map"
7381 Print "   7 = Exit Library-Computer"
7385 GoTo 7320
7390 Rem Setup to change Cumulative Galaxy record to Galaxy map.
7400 H8 = 0: G5 = 1: Print Space$(24); "The Galaxy": GoTo 7550
7530 Rem Cumluative Galactic Record.
7543 Print Space$(8);
7544 Print "Computer Record Of Galaxy For Quadrant"; Q1; ","; Q2
7546 Print
7550 Print "        1       2       3       4       5       6       7       8"
7560 O1$ = "     ------- ------- ------- ------- ------- ------- ------- ------"
7570 Print O1$: For I = 1 To 8: Print I;: If H8 = 0 Then 7740
   7630 For J = 1 To 8: Print "    ";: If Z(I, J) = 0 Then Print "****";: GoTo 7720
      7700 Print Right$(Str$(Z(I, J) + 10000), 4);
   7720 Next J: GoTo 7850
   7740 Z4 = I: Z5 = 1: GoSub 9030: J0 = Int(15 - .5 * Len(G2$)): Print Tab(J0); G2$;
   7800 Z5 = 5: GoSub 9030: J0 = Int(39 - .5 * Len(G2$)): Print Tab(J0); G2$;
7850 Print: Print O1$: Next I: Print: GoTo 7320

7890 Rem Status report.
7900 Print "   Status Report:": X$ = "": If K9 > 1 Then X$ = "S"
7940 Print "Klingon"; X$; " left: "; K9

7945 X$ = "": If R9 > 1 Then X$ = "S"
7946 Print "Romulan"; X$; " left: "; R9

7960 Print "Mission must be completed in"; .1 * Int((T0 + T9 - T) * 10); "stardates."
7970 X$ = "S": If B9 < 2 Then X$ = "": If B9 < 1 Then 8010
7980 Print "The Federation is maintaining"; B9; "starbase"; X$; " in the galaxy."
7984 GoSub 9300
7985 If P1 Then Print P1; "star destroyer torpedoes stocked." Else Print "Star destroyer torpedoes depleted."
7986 If G1 Then Print "Genesis device active." Else Print "Gensis device deactive."
7990 GoTo 7320
8010 Print "Your stupidity has left you on your own in"
8020 Print "  the galaxy -- you have no starbases left!": GoTo 5690
8060 Rem TORPEDO, BASE NAV, D/D CALCULATOR
8070 If K3 <= 0 Then Print "No Klingons found in quadrant.": H8 = 0: GoTo 8490
8080 X$ = "": If K3 > 1 Then X$ = "S"
8090 Print "From Enterprise to Klingon battle cruiser"; X$
8100 H8 = 0: For I = 1 To 4: If K(I, 3) <= 0 Then 8480
   8110 W1 = K(I, 1): X = K(I, 2)
   8115 Color White: Print "Klingon cruiser at sector:"; W1; ","; X
   8120 C1 = S1: A = S2: GoTo 8220
   8150 Color White: Print "Direction/Distance calculator:"
   8160 Print "You are at quadrant "; Q1; ","; Q2; " sector "; S1; ","; S2
   8170 Color Yellow: Print "Please enter": Input "  initial coordinates (X,Y)"; C1, A
   8200 Input "  Final coordinates (X,Y)"; W1, X
   8220 Color Yellow: X = X - A: A = C1 - W1: If X < 0 Then 8350
   8250 If A < 0 Then 8410
   8260 If X > 0 Then 8280
   8270 If A = 0 Then C1 = 5: GoTo 8290
   8280 C1 = 1
   8290 If Abs(A) <= Abs(X) Then 8330
   8310 Print "Direction ="; C1 + (((Abs(A) - Abs(X)) + Abs(A)) / Abs(A)): GoTo 8460
   8330 Print "Direction ="; C1 + (Abs(A) / Abs(X)): GoTo 8460
   8350 If A > 0 Then C1 = 3: GoTo 8420
   8360 If X <> 0 Then C1 = 5: GoTo 8290
   8410 C1 = 7
   8420 If Abs(A) >= Abs(X) Then 8450
   8430 Print "Direction ="; C1 + (((Abs(X) - Abs(A)) + Abs(X)) / Abs(X)): GoTo 8460
   8450 Print "Direction ="; C1 + (Abs(X) / Abs(A))
   8460 Print "Distance ="; Sqr(X ^ 2 + A ^ 2): If H8 = 1 Then 7320
8480 Next I
8490 If H8 = 0 Then GoSub 9375
8491 GoTo 7320
8500 If B3 <> 0 Then Print "From Enterprise to Starfleet Starbase:": W1 = B4: X = B5: GoTo 8120

8501 Rem detect vulcan starbase.
8505 If Q1 = VX And Q2 = VY Then Print "From Enterprise to Vulcan Starbase:": W1 = ZZ1: X = ZZ2: GoTo 8120

8506 Rem detect ferengi starbase.
8507 If Q1 = QX And Q2 = QY Then Print "From Enterprise to Ferengi Starbase:": W1 = ZZ3: X = ZZ4: GoTo 8120

8510 Print "Science Officer " + C4$ + " reports, 'Sensors show no starbases in this quadrant.'": GoTo 7320

8580 Rem Find empty place in quadrant.
8590 R1 = Int(Rnd * 8 + 1): R2 = Int(Rnd * 8 + 1): A$ = "   ": Z1 = R1: Z2 = R2: GoSub 8830: If Z3 = 0 Then 8590
8600 Return

8660 Rem Insert in string array for quadrant.
8670 S8 = Int(Z2 - .5) * 3 + Int(Z1 - .5) * 24 + 1
8675 If Len(A$) <> 3 Then A$ = "   "
8680 If S8 = 1 Then Q$ = A$ + Right$(Q$, 189): Return
8690 If S8 = 190 Then Q$ = Left$(Q$, 189) + A$: Return
8700 Q$ = Left$(Q$, S8 - 1) + A$ + Right$(Q$, 190 - S8): Return

8780 Rem Returns device name.
8790 On R1 GOTO 8792, 8794, 8796, 8798, 8800, 8802, 8804, 8806, 8807
8792 G2$ = "Warp Engines": Return
8794 G2$ = "Short Range Sensors": Return
8796 G2$ = "Long Range Sensors": Return
8798 G2$ = "Phaser Control": Return
8800 G2$ = "Photon Tubes": Return
8802 G2$ = "Damage Control": Return
8804 G2$ = "Shield Control": Return
8806 G2$ = "Library-Computer": Return
8807 G2$ = "Star Torpedoes": Return

8820 Rem Srinng comparison in quadrant array.
8830 Z1 = Int(Z1 + .5): Z2 = Int(Z2 + .5)
8840 S8 = (Z2 - 1) * 3 + (Z1 - 1) * 24 + 1: Z3 = 0
8890 If Mid$(Q$, S8, 3) <> A$ Then Return
8900 Z3 = 1: Return

9010 Rem Quadrant name in G2$ from Z4,Z5 (=Q1,Q2)
9020 Rem Call with G5=1 to get region name only.
9030 If Z5 <= 4 Then On Z4 GOTO 9040, 9050, 9060, 9070, 9080, 9090, 9100, 9110
9035 GoTo 9120
9040 G2$ = "ANTARES": GoTo 9210
9050 G2$ = "RIGEL": GoTo 9210
9060 G2$ = "PROCYON": GoTo 9210
9070 G2$ = "VEGA": GoTo 9210
9080 G2$ = "CANOPUS": GoTo 9210
9090 G2$ = "ALTAIR": GoTo 9210
9100 G2$ = "SAGITTARIUS": GoTo 9210
9110 G2$ = "POLLUX": GoTo 9210
9120 On Z4 GOTO 9130, 9140, 9150, 9160, 9170, 9180, 9190, 9200
9130 G2$ = "SIRIUS": GoTo 9210
9140 G2$ = "DENEB": GoTo 9210
9150 G2$ = "CAPELLA": GoTo 9210
9160 G2$ = "BETELGEUSE": GoTo 9210
9170 G2$ = "ALDEBARAN": GoTo 9210
9180 G2$ = "REGULUS": GoTo 9210
9190 G2$ = "ARCTURUS": GoTo 9210
9200 G2$ = "SPICA"
9210 If G5 <> 1 Then On Z5 GOTO 9230, 9240, 9250, 9260, 9230, 9240, 9250, 9260
9220 Return
9230 G2$ = G2$ + " I": Return
9240 G2$ = G2$ + " II": Return
9250 G2$ = G2$ + " III": Return
9260 G2$ = G2$ + " IV": Return

9265 Rem Locate and display coordinates of all Starbases in the galaxy.
9270 Color Yellow: Print "There is a Vulcan starbase at Quadrant"; VX; ","; VY
9271 Color Yellow: Print "There is a Ferengi starbase at Quadrant"; QX; ","; QY
9272 If B9 = 0 Then Print "There are no Federation Starbases.": GoTo 1990
9273 If B9 = 1 Then Print "There is 1 Federation Starbase in the galaxy."
9274 If B9 > 1 Then Print "There are"; B9; "Federation Starbases in the galaxy."
9275 For Z1 = 1 To 8: For Z2 = 1 To 8
      9291 QX$ = LTrim$(Str$(G(Z1, Z2)))
      9292 QX$ = Right$("000" + QX$, 3): QR = Int(Val(Mid$(QX$, 2, 1)) + .5)
      9293 If QR = 1 Then Print "There is 1 Federation Starbase at Quadrant"; Z1; ","; Z2
      9294 If QR > 1 Then Print "There are"; QR; "Federation Starbases at Quadrant"; Z1; ","; Z2
9295 Next Z2: Next Z1
9296 GoTo 1990

9297 Rem calculate and display rating.
9300 QR = T0 + T9 - T + .1: Color Yellow: Print "Rating for Captain "; CP$; ":"
9301 Color White: If QR = 0 Then Print "Your efficiency rating is zero.": Return
9302 If QR < 0 Then Print "Your efficiency rating is negative.": Return
9303 QZ = 1000 * ((K7 + R7) / QR) ^ 2: QX$ = Str$(QZ)
9304 If InStr(QX$, "E") Then Print "Your efficiency rating is unknown.": Return
9305 If UCase$(QX$) = "INF" Then Print "Your efficiency rating is unknown.": Return
9310 If InStr(QX$, ".") Then QX$ = Left$(QX$, InStr(QX$, ".") + 2)
9320 If QR > 0 Then Print "Your Efficiency rating is"; QX$
9350 Return

9351 Rem Locate and display coordinates of all klingons and romulans in the galaxy.
9352 Z = 0: If K9 = 1 Then Color Yellow: Print "There is 1 klingon in the galaxy."
9353 If K9 > 1 Then Color Yellow: Print "There are"; K9; "klingons in the galaxy."
9354 For Z1 = 1 To 8: For Z2 = 1 To 8
      9355 QX$ = LTrim$(Str$(G(Z1, Z2)))
      9356 QX$ = Right$("000" + QX$, 3)
      9357 QR = Int(Val(Left$(QX$, 1)) + .5)
      9358 If QR = 1 Then Color White: Print QR; "klingon at Quadrant"; Z1; ","; Z2: Z = -1
      9359 If QR > 1 Then Color White: Print QR; "klingons at Quadrant"; Z1; ","; Z2: Z = -1
9360 Next Z2: Next Z1: If Z = 0 Then Color White: Print "No klingons found."
9361 Color Yellow: Print "Press enter key";: Input X

9362 Z = 0: If R9 = 1 Then Color Yellow: Print "There is 1 romulan in the galaxy."
9363 If R9 > 1 Then Color Yellow: Print "There are"; R9; "romulans in the galaxy."
9364 For Z1 = 1 To 8: For Z2 = 1 To 8
      9365 QX$ = LTrim$(Str$(G(Z1, Z2)))
      9366 QX$ = Right$("0000" + QX$, 4)
      9367 QR = Int(Val(Left$(QX$, 1)) + .5)
      9368 If QR = 1 Then Color White: Print QR; "romulan at Quadrant"; Z1; ","; Z2: Z = -1
      9369 If QR > 1 Then Color White: Print QR; "romulans at Quadrant"; Z1; ","; Z2: Z = -1
9370 Next Z2: Next Z1: If Z = 0 Then Print "No romulans found."
9371 Color Yellow: Print "Press enter key";: Input X
9372 GoTo 1990

9373 Rem additional display for romulans.
9375 If R3 <= 0 Then Print "No Romulans found in quadrant.": Return
9376 X$ = "": If R3 > 1 Then X$ = "S"
9377 Print "From Enterprise to Romulan battle cruiser"; X$
9378 For I = 1 To 2: If R(I, 3) <= 0 Then 9400
   9379 W1 = R(I, 1): X = R(I, 2)
   9380 C1 = S1: A = S2
   9381 Color White: Print "Romulan cruiser at sector"; W1; ","; X
   9385 Color Yellow: X = X - A: A = C1 - W1: If X < 0 Then 9393
   9386 If A < 0 Then 9395
   9387 If X > 0 Then 9389
   9388 If A = 0 Then C1 = 5: GoTo 9390
   9389 C1 = 1
   9390 If Abs(A) <= Abs(X) Then 9392
   9391 Print " Direction ="; C1 + (((Abs(A) - Abs(X)) + Abs(A)) / Abs(A)): GoTo 9399
   9392 Print " Direction ="; C1 + (Abs(A) / Abs(X)): GoTo 9399
   9393 If A > 0 Then C1 = 3: GoTo 9396
   9394 If X <> 0 Then C1 = 5: GoTo 9390
   9395 C1 = 7
   9396 If Abs(A) >= Abs(X) Then 9398
   9397 Print " Direction ="; C1 + (((Abs(X) - Abs(A)) + Abs(X)) / Abs(X)): GoTo 9399
   9398 Print " Direction ="; C1 + (Abs(X) / Abs(A))
   9399 Print " Distance ="; Sqr(X ^ 2 + A ^ 2)
9400 Next I: Return

9409 Rem search galaxy.
9410 Color Yellow: Print "Enter 4-digit string(with ?) or 0 for prompts";: Input X$
9411 Color White: If X$ = "" Or X$ = "0" Then 9440
9412 If Len(X$) <> 4 Then 9410
9413 QZ$ = X$: For Z1 = 1 To 4
   9421 If Mid$(QZ$, Z1, 1) = "?" Or (Mid$(QZ$, Z1, 1) >= "0" And Mid$(QZ$, Z1, 1) <= "9") Then 9423
   9422 Color Red: Print "Invalid entry.": GoTo 9410
9423 Next Z1: GoTo 9454
9440 Color White: Print "Enter romulans(0-2)";: Input V1: V1 = Int(V1): If V1 >= 0 And V1 <= 2 Then 9447
9446 Color Yellow: Print "Invalid entry.": GoTo 9440
9447 Color White: Print "Enter klingons(0-4)";: Input V2: V2 = Int(V2): If V2 >= 0 And V2 <= 4 Then 9449
9448 Color Yellow: Print "Invalid entry.": GoTo 9447
9449 Color White: Print "Enter starbases(0-2)";: Input V3: V3 = Int(V3): If V3 >= 0 And V3 <= 2 Then 9451
9450 Color Yellow: Print "Invalid entry.": GoTo 9449
9451 Color White: Print "Enter stars(1-8)";: Input V4: V4 = Int(V4): If V4 >= 1 And V4 <= 8 Then 9453
9452 Color Yellow: Print "Invalid entry.": GoTo 9451
9453 QZ$ = LTrim$(Str$(V1)) + LTrim$(Str$(V2)) + LTrim$(Str$(V3)) + LTrim$(Str$(V4))
9454 ZX = 0: Color Red: Print "Searching Galaxy for "; QZ$
9455 Z = 0: For Z1 = 1 To 8: For Z2 = 1 To 8
      9456 QX$ = LTrim$(Str$(G(Z1, Z2))): QX$ = Right$("0000" + QX$, 4): Z$ = QX$
      9458 For Z3 = 1 To 4: If Mid$(QZ$, Z3, 1) = "?" Then Mid$(QX$, Z3, 1) = "?"
      9459 Next Z3
      9462 If QX$ <> QZ$ Then GoTo 9466
      9463 Z = -1: Color White: Print "Match "; Z$; " found at Quadrant"; Z1; ","; Z2
      9464 ZX = ZX + 1: If ZX >= 22 Then ZX = 0: GoSub 10001222: If X Then 1990
9466 Next Z2: Next Z1
9467 If Z = 0 Then Color White: Print "No matches in Galaxy found."
9468 Color Yellow: Print "Press enter key";: Input X
9470 Color White: GoTo 1990

9479 Rem display statusline.
9480 X = CsrLin: y = Pos(0)
9481 View Print 1 To 24
9482 Color White: Locate 24, 1: Print Space$(79);
9483 Locate 24, 1: Print "Starship: Quadrant"; Q1; ","; Q2; "Sector"; S1; ","; S2; "Shields"; S; "Energy"; E;
9484 Color Plain: View Print 1 To 23: Locate X, y
9485 Return

9579 Rem display startup statusline.
9580 X = CsrLin: y = Pos(0)
9581 View Print 1 To 24
9582 Color White: Locate 24, 1: Print Space$(79);
9583 Locate 24, 1: Print "Welcome to Super Startrek v5.0a";
9584 Color Plain: View Print 1 To 23: Locate X, y
9585 KEY 1, "KIRK": KEY 2, "SPOCK": KEY 3, "SCOTTY": KEY 4, "MCCOY": KEY 5, "CHECKOV"
9586 KEY 6, "SULU": KEY 7, "UHURHA": KEY 8, "CHAPEL": KEY 9, "RAND": KEY 10, "TRELANE": KEY 30, "": KEY 31, ""
9588 Names$(1) = "KIRK": Names$(2) = "SPOCK": Names$(3) = "SCOTTY": Names$(4) = "MCCOY": Names$(5) = "CHECKOV"
9589 Names$(6) = "SULU": Names$(7) = "UHURHA": Names$(8) = "CHAPEL": Names$(9) = "RAND": Names$(10) = "TRELANE"
9590 KEY On: Return

9591 Rem get captain name.
9592 For X = 6 To 10
   9593 If CX$ = Names$(X) Or CX2$ = Names$(X) Then 9595
   9594 R1$ = RTrim$(Names$(X)): Return
9595 Next
9596 R1$ = "GENERAL": Return

9597 Rem list of ships staff.
9598 For X = 1 To 10
   9599 Print Names$(X)
9600 Next
9601 Print "Press enter key";: Input X
9602 GoTo 1990

9603 Rem Executive order deletes enemies in nearby quadrants.
9604 If D0 = 3 Then 9607
9605 If E < 1000 Then Color Red: Print "Mr. " + C4$ + " declares 'Not enough energy to execute command.'": GoTo 1990
9607 Color Yellow: Print "Executive scan/delete for quadrant"; Q1; ","; Q2
9608 GoSub 7262: XQ = 0: For I = Q1 - 1 To Q1 + 1: For J = Q2 - 1 To Q2 + 1
      9617 If I > 0 And I < 9 And J > 0 And J < 9 Then 9619
      9618 GoTo 9630
      9619 If I = Q1 And J = Q2 Then GoSub 9637: GoTo 9630

      9620 Rem nearby quadrants
      9621 QQ$ = Right$("10000" + LTrim$(Str$(G(I, J))), 4)
      9622 R3x = Int(Val(Mid$(QQ$, 1, 1)) + .5)
      9623 K3x = Int(Val(Mid$(QQ$, 2, 1)) + .5)
      9624 B3x = Int(Val(Mid$(QQ$, 3, 1)) + .5)
      9625 S3x = Int(Val(Mid$(QQ$, 4, 1)) + .5)
      9626 R9 = R9 - R3x: K9 = K9 - K3x
      9627 XX = B3x * 10 + S3x
      9628 G(I, J) = XX: Z(I, J) = XX: If R3x > 0 Or K3x > 0 Then XQ = XQ + R3x + K3x
9630 Next J: Next I: If XQ = 0 Then Print "Mr. " + C4$ + " declares 'No enemies in the nearby quadrants found.'": GoTo 1990
9631 Print "Mr. " + C4$ + " declares '"; XQ; "enemies in nearby quadrants eradicated.'": If K9 <= 0 And R9 <= 0 Then 6370
9632 If D0 = 3 Then Print "Ferengis payed the cost of your Executive Order.": GoTo 1990
9634 E = E - 1000: If E <= 10 Then E = 10
9635 Color White: Print "Mr. " + C4$ + " reports 'Energy now"; E; "units."; "'": GoTo 1990

9636 Rem current quadrant
9637 For K = 1 To 4: If K(K, 3) <= 0 Then 9639
   9638 K(K, 3) = 0: K3 = K3 - 1: K9 = K9 - 1: Z1 = K(K, 1): Z2 = K(K, 2): A$ = "   ": GoSub 8670: XQ = XQ + 1
9639 Next K
9640 For K = 1 To 2: If R(K, 3) <= 0 Then 9642
   9641 R(K, 3) = 0: R3 = R3 - 1: R9 = R9 - 1: Z1 = R(K, 1): Z2 = R(K, 2): A$ = "   ": GoSub 8670: XQ = XQ + 1
9642 Next K
9643 G(Q1, Q2) = B3 * 10 + S3: Z(Q1, Q2) = G(Q1, Q2): Return

9644 Rem init top 10 datafile.
9645 Close #1
9647 Open FL$ For Random As #1 Len = 52
9669 Field #1, 30 As U$, 4 As T$, 10 As D1$, 8 As T2$
9672 If LOF(1) / 52 = 0 Then
   9673 GoSub 9801
   9674 U1$ = Names$(1): T1 = Z1: If T1 = 0 Then T1 = 10
   9675 LSet U$ = U1$: LSet T$ = MKS$(T1): LSet D1$ = Date$: LSet T2$ = Time$
   9676 Put #1, 1!
9680 End If
9681 Return

9682 Rem force init top 10 datafile.
9685 Color Yellow: Print "Top 10 datafile initialized."
9686 Close #1
9687 Open FL$ For Binary As #1
9688 Close #1
9689 Kill FL$: GoTo 9645

9800 Rem calculate score.
9801 Z1 = 0: QR = T0 + T9 - T + .1
9803 If QR <= 0 Then Return
9804 Z1 = 1000 * ((K7 + R7) / QR) ^ 2: QX$ = Str$(Z1)
9805 If InStr(QX$, "E") Then Z1 = 0: Return
9806 If UCase$(QX$) = "INF" Then Z1 = 0: Return
9807 Return

9808 Rem update top 10 datafile.
9810 Close #1
9812 Open FL$ For Random As #1 Len = 52
9814 Field #1, 30 As U$, 4 As T$, 10 As D1$, 8 As T2$
9815 V! = LOF(1) / 52
9816 For V2! = 1! To V!
   9817 Get #1, V2!
   9818 U1$ = RTrim$(U$): U2$ = UCase$(CP$)
   9819 If U1$ = U2$ Then 9821
   9820 GoTo 9825
   9821 GoSub 9801: T1 = Z1: If T1 = 0 Then T1 = 10
   9822 LSet D1$ = Date$: LSet T2$ = Time$: LSet T$ = MKS$(T1): Put #1, V2!: Return
9825 Next V2!: GoSub 9801: T1 = Z1: If T1 = 0 Then T1 = 10
9826 LSet U$ = UCase$(CP$): LSet T$ = MKS$(T1): LSet D1$ = Date$: LSet T2$ = Time$
9827 V! = LOF(1) / 52 + 1!: Put #1, V!: Return

9828 Rem bubble sort top 10 datafile.
9830 Close #1
9832 Open FL$ For Random As #1 Len = 52
9834 Field #1, 30 As U$, 4 As T$, 10 As D1$, 8 As T2$
9835 V! = LOF(1) / 52
9836 For V1! = 1! To V!
   9837 For V2! = V1! To V!
      9838 Get #1, V1!: U1$ = U$: T1 = CVS(T$): X1$ = D1$: Y1$ = T2$
      9839 Get #1, V2!: U2$ = U$: T2 = CVS(T$): X2$ = D1$: Y2$ = T2$
      9840 If T1 < T2 Then 9842
      9841 GoTo 9845
      9842 LSet U$ = U2$: LSet T$ = MKS$(T2): LSet D1$ = X2$: LSet T2$ = Y2$: Put #1, V1!
      9843 LSet U$ = U1$: LSet T$ = MKS$(T1): LSet D1$ = X1$: LSet T2$ = Y1$: Put #1, V2!
9845 Next V2!: Next V1!: Return

9849 Rem display top 10 datafile.
9850 GoSub 9810: GoSub 9830: Color White
9851 Print "Captains Name                   Rating  Date/Time"
9852 Print "-----------------------------   ------  ---------"
9854 Close #1
9855 Open FL$ For Random As #1 Len = 52
9857 Field #1, 30 As U$, 4 As T$, 10 As D1$, 8 As T2$
9858 V! = LOF(1) / 52: If V! > 10! Then V! = 10!
9859 For V1! = 1! To V!
   9860 Get #1, V1!
   9861 U1$ = RTrim$(U$): T1 = CVS(T$)
   9862 U1$ = LCase$(U1$): Mid$(U1$, 1, 1) = UCase$(Mid$(U1$, 1, 1))
   9863 QX$ = Str$(T1): If InStr(QX$, ".") Then QX$ = Left$(QX$, InStr(QX$, ".") + 2)
   9864 U1$ = U1$ + Space$(30 - Len(U1$))
   9865 Color Yellow: Print U1$; " "; QX$; "  "; D1$ + "/" + T2$
9870 Next V1!
9871 Color White: Print "Press enter key";: Input X
9872 GoTo 1990

9944 Rem write top 10 textfile.
9945 GoSub 9810: GoSub 9830: Color White
9947 Close #2
9948 Open FL2 For Output As #2
9949 Close #3
9950 Open FL3 For Output As #3
9951 Print #2, "Captains Name                   Rating  Date/Time"
9952 Print #2, "-----------------------------   ------  ---------"
9953 Print #3, Chr$(27) + "[0;1;37m" + "Captains Name                   Rating  Date/Time"
9957 Print #3, Chr$(27) + "[0;1;37m" + "-----------------------------   ------  ---------"
9959 Close #1
9960 Open FL$ For Random As #1 Len = 52
9962 Field #1, 30 As U$, 4 As T$, 10 As D1$, 8 As T2$
9963 V! = LOF(1) / 52: If V! > 10! Then V! = 10!
9964 For V1! = 1! To V!
   9965 Get #1, V1!
   9966 U1$ = RTrim$(U$): T1 = CVS(T$)
   9967 U1$ = LCase$(U1$): Mid$(U1$, 1, 1) = UCase$(Mid$(U1$, 1, 1))
   9968 QX$ = Str$(T1): If InStr(QX$, ".") Then QX$ = Left$(QX$, InStr(QX$, ".") + 2)
   9969 U1$ = U1$ + Space$(30 - Len(U1$))
   9970 Print #2, U1$; " "; QX$; " "; D1$; "/"; T2$
   9971 Print #3, Chr$(27) + "[0;1;33m" + U1$ + " " + QX$ + " " + D1$ + "/" + T2$
9972 Next V1!
9973 Print #3, Chr$(27) + "[0m"
9974 Return

9976 Rem subroutine to save current game.
9977 Color White: Print "Enter save game(000-999)";: Input FX
9978 FX = Int(FX): If FX >= 0 And FX <= 999 Then 9980
9979 Color Red: Print "Save game error.": Return
9980 Close #1
9981 FX$ = Right$("000" + LTrim$(Str$(FX)), 3)
9982 FX$ = "STREK" + FX$ + ".SAV"
9983 Rem Store Game.
9984 Open FX$ For Output As #1
9985 Print #1, CP$: Print #1, C1$: Print #1, C2$
9986 For I = 1 To 8: For J = 1 To 8: Print #1, G(I, J): Print #1, Z(I, J): Next J: Next I
9987 For I = 1 To 9: For J = 1 To 2: Print #1, C(I, J): Next J: Next I
9988 For I = 1 To 4: For J = 1 To 3: Print #1, K(I, J): Print #1, R(I, J): Next J: Next I
9989 For I = 1 To 9: Print #1, D(I): Next I
9990 Print #1, T: Print #1, T0: Print #1, T9: Print #1, D0: Print #1, E: Print #1, E0: Print #1, Q9: Print #1, G1
9991 Print #1, P1: Print #1, P: Print #1, P0: Print #1, S9: Print #1, S: Print #1, B9: Print #1, K9: Print #1, R9
9992 Print #1, VX: Print #1, VY: Print #1, QX: Print #1, QY
9993 Print #1, Q1: Print #1, Q2: Print #1, S1: Print #1, S2
9994 Print #1, Cash: Print #1, Q$
9995 Color Yellow: Print "Game "; FX$; " written to disk."
9996 Return

9999 Rem subroutine to load a stored game.
10000 Color White: Print "Enter load game(000-999,-1=list)";: Input FX
10001 If FX < 0 Then
   10002 Color Red: Print "List of Strek Games": Color White: Files "STREK*.SAV"
   10003 SX = -2: Return
10004 End If
10009 On Error GoTo 10102
10010 SX = 0: FX = Int(FX): If FX >= 0 And FX <= 999 Then 10030
10020 Color Red: Print "Load game error.": SX = -1: GoTo 10100
10030 Close #1
10040 FX$ = Right$("000" + LTrim$(Str$(FX)), 3)
10050 FX$ = "STREK" + FX$ + ".SAV"
10051 Open FX$ For Binary As #1
10052 If LOF(1) > 0 Then 10065
10053 Color Red: Print "Load game error.": SX = -2
10054 Print "Cannot load: "; FX$
10055 Rem avoid leaving zero-length file.
10056 Close #1
10057 Kill FX$
10058 GoTo 10100
10060 Rem ReStore Game.
10065 Close #1
10070 Open FX$ For Input As #1
10080 Line Input #1, CP$: Line Input #1, C1$: Line Input #1, C2$
10090 For I = 1 To 8: For J = 1 To 8: Input #1, G(I, J): Input #1, Z(I, J): Next J: Next I
10091 For I = 1 To 9: For J = 1 To 2: Input #1, C(I, J): Next J: Next I
10092 For I = 1 To 4: For J = 1 To 3: Input #1, K(I, J): Input #1, R(I, J): Next J: Next I
10093 For I = 1 To 9: Input #1, D(I): Next I
10094 Input #1, T: Input #1, T0: Input #1, T9: Input #1, D0: Input #1, E: Input #1, E0: Input #1, Q9: Input #1, G1
10095 Input #1, P1: Input #1, P: Input #1, P0: Input #1, S9: Input #1, S: Input #1, B9: Input #1, K9: Input #1, R9
10096 Input #1, VX: Input #1, VY: Input #1, QX: Input #1, QY
10097 Input #1, Q1: Input #1, Q2: Input #1, S1: Input #1, S2
10098 Input #1, Cash: Line Input #1, Q$
10099 Color Yellow: SX = 0: Print "Game "; FX$; " loaded."
10100 On Error GoTo 10001216
10101 Return
10102 Color Red: Print "Load game error:"; Err; "line"; Erl
10103 Print "Cannot load: "; FX$: SX = -1
10104 Resume 10100

100019 Rem display instructions textfile.
100020 Color Yellow: Input "Do you need instructions(Y/N)"; K$: K$ = UCase$(K$)
100041 If K$ = "N" Then Return
100042 If K$ = "Y" Then GoTo 100044
100043 GoTo 100020
100044 Close #1
100045 Open FL1 For Binary As #1
100046 If LOF(1) = 0 Then Color Red: Print "Instruction file not found.": Return
100050 Close #1
100060 Open FL1 For Input As #1
100070 Color White: X = 0: Z = 0: Do
   100072 If EOF(1) Then Exit Do
   100075 Line Input #1, X$: If Left$(X$, 1) = ";" Then GoTo 100084
   100076 GoSub 100085: If X Then Exit Do
   100077 Print X$
   100078 Z = Z + 1
   100079 If Z >= 22 Then
      100080 Z = 0
      100081 GoSub 10001222
      100082 If X Then Exit Do
   100083 End If
100084 Loop: Color Yellow: Print "End of instructions.": Return

100085 If Left$(UCase$(X$), 11) = "COLOR WHITE" Then Color White: X$ = Mid$(X$, 12)
100086 If Left$(UCase$(X$), 12) = "COLOR YELLOW" Then Color Yellow: X$ = Mid$(X$, 13)
100087 If Left$(UCase$(X$), 11) = "COLOR GREEN" Then Color Green: X$ = Mid$(X$, 12)
100088 If Left$(UCase$(X$), 9) = "COLOR RED" Then Color Red: X$ = Mid$(X$, 10)
100089 If Left$(UCase$(X$), 13) = "COLOR MAGENTA" Then Color Magenta: X$ = Mid$(X$, 14)
100090 If Left$(UCase$(X$), 10) = "COLOR BLUE" Then Color Blue: X$ = Mid$(X$, 11)
100091 If Left$(UCase$(X$), 10) = "COLOR CYAN" Then Color Cyan: X$ = Mid$(X$, 11)
100092 If Left$(UCase$(X$), 11) = "COLOR PLAIN" Then Color Plain: X$ = Mid$(X$, 12)
100093 If Left$(UCase$(X$), 5) = "PAUSE" Then Z = 0: X$ = Mid$(X$, 6): GoSub 10001222
100094 V = InStr(UCase$(X$), "DATE$"): If V Then X$ = Left$(X$, V - 1) + Date$ + Mid$(X$, V + 5)
100095 V = InStr(UCase$(X$), "TIME$"): If V Then X$ = Left$(X$, V - 1) + Time$ + Mid$(X$, V + 5)
100096 V = InStr(UCase$(X$), "CLOCK$"): If V Then X$ = Left$(X$, V - 1) + Date$ + " " + Time$ + Mid$(X$, V + 6)
100097 V = InStr(UCase$(X$), "VERSION$"): If V Then X$ = Left$(X$, V - 1) + "v5.0a" + Mid$(X$, V + 9)
100098 Return

10001215 Rem Trap any error.
10001216 Print "Critical error"; Err; "line"; Erl: If Err = 9 Then Print "Subscript out of bounds."
10001217 Print "Enter Q to quit or R to resume:"
10001218 Do: X$ = InKey$: X$ = UCase$(X$)
   10001219 If X$ = "R" Then Resume Next
   10001220 If X$ = "Q" Then GoTo 10001231
10001221 Loop: End

10001222 X = 0: Color Yellow: Print "Press enter key to continue or any other key to quit:";
10001223 Do
   10001224 X1$ = InKey$
   10001225 If Len(X1$) Then
      10001226 If X1$ = Chr$(13) Then Color White: Print: Return
      10001227 X = -1: Print: Return
   10001228 End If
10001229 Loop

10001230 Rem game ends here.
10001231 On Error GoTo 10001238
10001232 View Print 1 To 24
10001233 Locate 24, 1
10001234 Print Space$(78);
10001235 KEY Off
10001236 Rem update/write top 10 report.
10001237 GoSub 9810: GoSub 9945
10001238 End

10001240 Rem END OF PROJECT

